/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#include "gdambeatinfo.h"
#include <glib.h>


GdamBeatInfo*	gdam_beat_info_new	()
{
	return g_new0(GdamBeatInfo, 1);
}

double		gdam_beat_info_get_bpm	(const GdamBeatInfo*	beat_info,
				       	 float			position)
{
	return beat_info ? beat_info->abpm : 0;
}

double		gdam_beat_info_get_first_beat	
					(const GdamBeatInfo*	beat_info,
				       	 float			position)
{
	return beat_info ? beat_info->afirst_beat : 0;
}

double		gdam_beat_info_get_beat_length	
					(const GdamBeatInfo*	beat_info,
				       	 float			position)
{
	return beat_info ? (60.0 / beat_info->abpm) : 0;
}

void		gdam_beat_info_set_bpm	(GdamBeatInfo*		beat_info,
					 double		new_bpm)
{
	beat_info->abpm = new_bpm;
}

void		gdam_beat_info_set_first_beat	
					(GdamBeatInfo*		beat_info,
					 double		new_first_beat)
{
	beat_info->afirst_beat = new_first_beat;
}

GdamBeatInfo*	gdam_beat_info_copy	(const GdamBeatInfo*	beat_info)
{
	GdamBeatInfo* rv = g_new0(GdamBeatInfo, 1);
	rv->abpm =  beat_info->abpm;
	rv->afirst_beat = beat_info->afirst_beat;
	return rv;
}
